 
 *---独生子女的商业保险购买决策：基于中国家庭追踪调查（CFPS）数据的证据---------
 
 
 clear all
 set more off 
 cd  
 global T="F:\"

 global X1 "male age education spouse job health"
 global X2 "male age education spouse job health otherins familysize snfyb lnfyb lnincome_hh lnasset"
 
 *ssc install ftools
 *ssc install reghdfe
 *ssc install outreg2
 *ssc install ivreg2 


 *-----------------------------------------------------------1.数据清洗与变量生成--------------------------------------------------------------
 use 2014all,clear
 *oldnum和nadultnum为家庭的老人和未成年人数量
  merge 1:1 fid14 using 2014oldnum
  drop if _merge==2
  replace oldnum=0 if _merge==1
  drop _merge
  merge 1:1 fid14 using 2014nadultnum
  drop if _merge==2
  replace nadultnum=0 if _merge==1
  drop _merge
  set more off
  replace health=5-health /*健康*/

  ren gender male

  g otherins1=(qp605_s_1>=1& qp605_s_1<=4)  /*医疗保险*/
  g otherins2=(qi301_s_1==1|qi301_s_1==2|qi301_s_1==3|qi301_s_1==5|qi301_s_1==6|qi301_s_1==7)  /*养老保险*/
  g otherins=(otherins1==1|otherins2==1)    /*社会保障*/

  g d_car=(fs6_s_1==1) /*是否有车*/

  g ln_ins=log(1+insurvalue)


  g jrsy_1=(fw3==1)
  g jrsy_2=(fw4==2)
  g jrsy_3=(fw5==3)
  g jrsy_4=(fw6==1)
  g jrsy_5=(fw7==1)
  g jrsy=jrsy_1+jrsy_2+jrsy_3+jrsy_4+jrsy_5

  g risk1=4-fw241 if fw241>0  /*风险态度*/

  g shhd=rqlzc/1000  
  replace shhd=0 if shhd==.
  drop if shhd <0
  
  g snrkzb=nadultnum/familysize
  g snfyb=nadultnum/(familysize-nadultnum-oldnum)
  g lnrkzb=oldnum/familysize
  g lnfyb=oldnum/(familysize-nadultnum-oldnum)

*--------------------------------------------------------------2.描述性统计（表1）---------------------------------------------------------
  local vars "insur onechild male age education spouse job health otherins familysize snfyb lnfyb  lnincome_hh lnasset provcd14"
  foreach i of local vars{
	drop if `i'==.
  }
  replace shhd=0 if shhd==.|shhd<0
  replace qn10024=. if qn10024<0
  replace qn10025=. if qn10025<0
  replace qn10021=. if qn10021<0
  replace qn10022=. if qn10022<0
  *drop if proname=="内蒙古自治区"|proname=="海南省"
  su insur onechild $X2 jrsy risk1 shhd qn10024 qn10022 qn10021 qn10025


*--------------------------------------------------------------3.基准回归结果（表2）-----------------------------------------------------------

  areg insur onechild,absorb(provcd14) vce(robust)
  est store REG1
  areg insur onechild $X1 ,absorb(provcd14)  vce(robust)
  est store REG2
  areg insur onechild $X2 ,absorb(provcd14) vce(robust)
  est store REG3

  probit insur onechild i.provcd14,vce(robust)
  est store REG4
  *margins,dydx(*)
  probit insur onechild $X1 i.provcd14 ,vce(robust)
  est store REG5
  probit insur onechild $X2 i.provcd14,vce(robust)
  est store REG6
  outreg2 [*] using $T\表2.doc ,bd(3)sd(3)
  est clear

  *---------------------------------------------------------------4.稳健性检验（表3）----------------------------------------------------------
  *2.1 使用保险金额
  areg ln_ins onechild $X2 ,absorb(provcd14) vce(robust)
  est store value
  *2.2 去除户主从事金融业
  areg insur onechild $X2 if indus!=10,absorb(provcd14) vce(robust)
  est store OLS1
  probit insur onechild $X2  i.provcd14 if indus!=10,vce(robust)
  est store PROB1
  *margins,dydx(*)
  *2.3 去除有汽车家庭
  areg insur onechild $X2 if d_car!=1,absorb(provcd14) vce(robust)
  est store OLS2
  probit insur onechild $X2 i.provcd14 if d_car!=1,vce(robust)
  est store PROB2

  outreg2 [*] using $T\表3主.doc ,bd(3)sd(3)
  est clear
  *2.4 同时使用2010.2012年样本
  use 2014all,clear
  merge 1:1 fid14 using 2014oldnum
  drop if _merge==2
  replace oldnum=0 if _merge==1
  drop _merge
  merge 1:1 fid14 using 2014nadultnum
  drop if _merge==2
  replace nadultnum=0 if _merge==1
  drop _merge
  set more off
  replace health=5-health /*值越大越健康*/

  ren gender male

  g otherins1=(qp605_s_1>=1& qp605_s_1<=4)  /*医疗保险*/
  g otherins2=(qi301_s_1==1|qi301_s_1==2|qi301_s_1==3|qi301_s_1==5|qi301_s_1==6|qi301_s_1==7)  /*养老保险*/
  g otherins=(otherins1==1|otherins2==1)    /*社会保障*/

  g d_car=(fs6_s_1==1) /*是否有车*/

  g ln_ins=log(1+insurvalue)
  g shhd=rqlzc/1000 
  replace shhd=0 if shhd==.
  drop if shhd <0
  g snrkzb=nadultnum/familysize
  g snfyb=nadultnum/(familysize-nadultnum-oldnum)
  g lnrkzb=oldnum/familysize
  g lnfyb=oldnum/(familysize-nadultnum-oldnum)
  g year=2014
  rena provcd14 provcd

  append using 2010p
  append using 2012p
  drop if year==2014

  reghdfe insur onechild $X2 ,absorb(provcd year) vce(robust)
  est store OLS3
  probit insur onechild $X2 i.provcd i.year ,vce(robust)
  est store PROB3
  outreg2 [*] using $T\表3副.doc ,bd(3)sd(3)
  est clear

  *---------------------------------------------------------------5.内生性处理----------------------------------------------------------
  use 2014all,clear

  sort prot birthyear
  merge m:1 prot birthyear using new_fine
  tab _merge
  tab proname if _merge==2
  *order province birthyear
  drop if _merge==2
  drop _merge

  replace f_fine=0 if birthyear<1980
  replace f_bonus=0 if birthyear<1980


  merge 1:1 fid14 using 2014oldnum
  drop if _merge==2
  replace oldnum=0 if _merge==1
  drop _merge
  merge 1:1 fid14 using 2014nadultnum
  drop if _merge==2
  replace nadultnum=0 if _merge==1
  drop _merge
  set more off
  replace health=5-health /*值越大越健康*/

  ren gender male

  g otherins1=(qp605_s_1>=1& qp605_s_1<=4)  /*医疗保险*/
  g otherins2=(qi301_s_1==1|qi301_s_1==2|qi301_s_1==3|qi301_s_1==5|qi301_s_1==6|qi301_s_1==7)  /*养老保险*/
  g otherins=(otherins1==1|otherins2==1)    /*社会保障*/

  g d_car=(fs6_s_1==1) /*是否有车*/

  g ln_ins=log(1+insurvalue)


  g jrsy_1=(fw3==1)
  gen jrsy_2=(fw4==2)
  gen jrsy_3=(fw5==3)
  gen jrsy_4=(fw6==1)
  gen jrsy_5=(fw7==1)
 
  gen jrsy=jrsy_1+jrsy_2+jrsy_3+jrsy_4+jrsy_5

  g risk1=4-fw241 if fw241>0  /*风险态度*/

  g shhd=rqlzc/1000

  g snrkzb=nadultnum/familysize
  g snfyb=nadultnum/(familysize-nadultnum-oldnum)
  g lnrkzb=oldnum/familysize
  g lnfyb=oldnum/(familysize-nadultnum-oldnum)

  local vars "insur onechild male age education spouse job health otherins familysize snfyb lnfyb  lnincome_hh lnasset provcd14"
  foreach i of local vars{
	drop if `i'==.
}
  replace shhd=0 if shhd==.
  drop if shhd <0
  replace qn10024=. if qn10024<0
  replace qn10025=. if qn10025<0
  replace qn10021=. if qn10021<0
  replace qn10022=. if qn10022<0
  *drop if proname=="内蒙古自治区"|proname=="海南省"

  ivregress 2sls insur   (onechild=f_fine) $X2 i.provcd14, robust first 
  est store IV1

  ivprobit insur (onechild=f_fine)  $X2 i.provcd14,first twostep
  est store IV2

  ivregress 2sls insur  (onechild=f_bonus) $X2 i.provcd14, robust first 
  est store IV3

  ivprobit insur (onechild=f_bonus) $X2 i.provcd14,first twostep
  est store IV4

  ivregress 2sls insur  (onechild=post) $X2 i.provcd14, robust first 
  est store IV5

  ivprobit insur (onechild=post) $X2 i.provcd14,first twostep
  est store IV6

  outreg2 [*] using $T\表4.doc ,bd(3)sd(3)
  est clear

*---------------------------------------------------------------6.机制分析----------------------------------------------------------

 use 2014all,clear

  merge 1:1 fid14 using 2014oldnum
  drop if _merge==2
  replace oldnum=0 if _merge==1
  drop _merge
  merge 1:1 fid14 using 2014nadultnum
  drop if _merge==2
  replace nadultnum=0 if _merge==1
  drop _merge
  set more off
  replace health=5-health /*值越大越健康*/

  ren gender male

  g otherins1=(qp605_s_1>=1& qp605_s_1<=4)  /*医疗保险*/
  g otherins2=(qi301_s_1==1|qi301_s_1==2|qi301_s_1==3|qi301_s_1==5|qi301_s_1==6|qi301_s_1==7)  /*养老保险*/
  g otherins=(otherins1==1|otherins2==1)    /*社会保障*/

  g d_car=(fs6_s_1==1) /*是否有车*/

  g ln_ins=log(1+insurvalue)

  g jrsy_1=(fw3==1)
  g jrsy_2=(fw4==2)
  g jrsy_3=(fw5==3)
  g jrsy_4=(fw6==1)
  g jrsy_5=(fw7==1)
  g jrsy=jrsy_1+jrsy_2+jrsy_3+jrsy_4+jrsy_5

  g risk1=4-fw241 if fw241>0  /*风险态度*/

  g shhd=rqlzc/1000

  gen snrkzb=nadultnum/familysize
  gen snfyb=nadultnum/(familysize-nadultnum-oldnum)
  gen lnrkzb=oldnum/familysize
  gen lnfyb=oldnum/(familysize-nadultnum-oldnum)

  replace shhd=. if shhd<0
  replace qn10024=. if qn10024<0
  replace qn10025=. if qn10025<0
  replace qn10021=. if qn10021<0
  replace qn10022=. if qn10022<0
  drop if proname=="内蒙古自治区"|proname=="海南省"


  *表5：机制探究--金融知识及风险态度
  areg jrsy onechild $X2 ,absorb(provcd14)vce(robust)
  est store REG1
  areg insur  onechild jrsy $X2 ,absorb(provcd14)vce(robust)
  est store REG2
  areg risk1 onechild $X2 ,absorb(provcd14)vce(robust)
  est store REG3
  areg insur  onechild risk1 $X2 ,absorb(provcd14)vce(robust)
  est store REG4

  outreg2 [*] using $T\表5.doc ,bd(3)sd(3)
  est clear

  *表6：机制探究——社会互动及信任度
  areg shhd onechild $X2 ,absorb(provcd14)vce(robust)
  est store REG1
  areg qn10024 onechild $X2 ,absorb(provcd14)vce(robust)
  est store REG2
  areg qn10022 onechild $X2 ,absorb(provcd14)vce(robust)
  est store REG3
  areg qn10021 onechild $X2 ,absorb(provcd14)vce(robust)
  est store REG4
  areg qn10025 onechild $X2 ,absorb(provcd14)vce(robust)
  est store REG5

  outreg2 [*] using $T\表6.doc ,bd(3)sd(3)
  est clear

  **表7：进一步分析-社会互动及信任度
  areg insur  onechild  shhd $X2 ,absorb(provcd14)vce(robust)
  est store REG1
  areg insur  onechild  qn10024 $X2 ,absorb(provcd14)vce(robust)
  est store REG2
  areg insur  onechild  shhd qn10024 $X2 ,absorb(provcd14)vce(robust)
  est store REG3
  probit insur onechild shhd $X2 i.provcd14,vce(robust)
  est store PROB1
  probit insur onechild qn10024 $X2 i.provcd14,vce(robust)
  est store PROB2
  probit insur onechild shhd qn10024 $X2 i.provcd14,vce(robust)
  est store PROB3

  outreg2 [*] using $T\表7.doc ,bd(3)sd(3)
  est clear
